PD = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0")
local frame, damag, typed
local a, d, dn, dt, f, x, y, p1, p2, h, v, t
local L = setmetatable({}, { __index = function(self, key) rawset(self, key, key) return key end }) PD.L = L

function PD:OnInitialize()
	self:RegisterDB("pddb", "pdChardb")
	self:RegisterDefaults('profile', {
		alignH = "CENTER",
		alignV = "TOP",
		colorDamag = "ffffff",
		colorTyped = "ffffff",
		fontFace = "Friz Quadrata TT",
		fontSizeDamag = 32,
		fontSizeTyped = 16,
		pos = "CENTER",
		posX = 0,
		posY = 0
	})
	self:RegisterDefaults('char', {
		damtype = "7",
		seconda = ""
	})

	self:LoadOptions()
end

function PD:UpdateText()
	d = self.db.char.damtype or "1"
	if d == "1" then dn = "Physical Power" dt = GetSpellBonusDamage(1)
	elseif d == "2" then dn = "Holy Damage" dt = GetSpellBonusDamage(2)
	elseif d == "3" then dn = "Fire Damage" dt = GetSpellBonusDamage(3)
	elseif d == "4" then dn = "Nature Damage" dt = GetSpellBonusDamage(4)
	elseif d == "5" then dn = "Frost Damage" dt = GetSpellBonusDamage(5)
	elseif d == "6" then dn = "Shadow Damage" dt = GetSpellBonusDamage(6)
	elseif d == "7" then dn = "Arcane Damage" dt = GetSpellBonusDamage(7)
	elseif d == "8" then dn = "Healing Power" dt = GetSpellBonusHealing()
	elseif d == "9" then dn = "Attack Power" local base, posBuff, negBuff = UnitAttackPower("player"); dt = base + posBuff + negBuff;
	end

	damag:SetText("|cffffffff"..dt.."|r")
	typed:SetText("|cffffffff"..dn.."|r")
end

function PD:UpdateScheduledEvents()
	self:CancelAllScheduledEvents()
	self:ScheduleRepeatingEvent(self.UpdateText, 0.2, self)
	self:UpdateText()
end

function PD:UpdatePosition()
	a = self.db.profile.pos
	x = a:find("RIGHT") and -self.db.profile.posX or self.db.profile.posX
	y = a:find("TOP") and -self.db.profile.posY or self.db.profile.posY
	h = self.db.profile.align or "CENTER"
	v = self.db.profile.grow or "DOWN"

	frame:ClearAllPoints()
	frame:SetPoint(a, UIParent, a, x, y)

	if h == "LEFT" then
		p1 = v == "UP" and "BOTTOMLEFT" or "TOPLEFT"
		p2 = v == "UP" and "TOPLEFT" or "BOTTOMLEFT"
	elseif h == "RIGHT" then
		p1 = v == "UP" and "BOTTOMRIGHT" or "TOPRIGHT"
		p2 = v == "UP" and "TOPRIGHT" or "BOTTOMRIGHT"
	else
		p1 = v == "UP" and "BOTTOM" or "TOP"
		p2 = v == "UP" and "TOP" or "BOTTOM"
	end

	damag:SetPoint(p1, frame, p1, 0, 0)
	damag:SetJustifyH(h)

	typed:SetPoint(p1, damag, p2, 0, 0)
	typed:SetJustifyH(h)
end

function PD:UpdateFonts()
	t = SML and SML:Fetch("font", self.db.profile.fontFace) or "Fonts\\FRIZQT__.ttf"

	damag:SetFont(t, self.db.profile.fontSizeDamag, self.db.profile.fontOutline)
	typed:SetFont(t, self.db.profile.fontSizeTyped, self.db.profile.fontOutline)

	if self.db.profile.fontShadow then
		damag:SetShadowOffset(1, -1)
		typed:SetShadowOffset(1, -1)
	else
		damag:SetShadowOffset(0, 0)
		typed:SetShadowOffset(0, 0)
	end

	damag:SetText("0000")
	typed:SetText("Arcane Damage")
	frame:SetWidth(typed:GetWidth() > damag:GetWidth() and typed:GetWidth() or damag:GetWidth())
	frame:SetHeight(damag:GetHeight() + typed:GetHeight())
end

----------------------------------------------------------------
-- Initialize
----------------------------------------------------------------

function PD:OnEnable()
	if not PD_Frame then
		frame = CreateFrame("Frame", "PD_Frame", UIParent)
		frame:SetFrameStrata("BACKGROUND")
		frame:SetFrameLevel(0)
	
		damag = frame:CreateFontString("PD_Damag", "OVERLAY")
		typed = frame:CreateFontString("PD_Typed", "OVERLAY")
	
		self:UpdateFonts()
		self:UpdatePosition()
	
		frame:Show()
	end
	self:UpdateScheduledEvents()
end

function PD:OnDisable()
	PD_Damag:SetText()
	PD_Typed:SetText()
	PD_Frame:Hide()
end